use Gtk;
init Gtk;

use strict;

package File2DiVX3Pass;

my $true  = 1;
my $false = 0;
my $VERSION = "1.0b5";



sub new
{
	my $class = shift;
	my $widgets;

	my @menu_items = (
		{ path        => '/_File',
     		type        => '<Branch>' },
	   		{ path        => '/File/_New project',
     			accelerator => '<control>N',
     			callback    =>  sub { MenuNew($widgets) } },
	   		{ path        => '/File/_Open project',
     			accelerator => '<control>O',
     			callback    => sub { MenuOpen($widgets) } },
	   		{ path        => '/File/_Save project',
     			accelerator => '<control>S',
     			callback    => sub { MenuSave($widgets) } },

   		{ path        => '/File/sep1',
     		type        => '<Separator>' },

   		{ path        => '/File/_Batch encode',
     		accelerator => '<control>B',
     		callback    => sub{ MenuBatchEncode($widgets) } },

   		{ path        => '/File/sep2',
     		type        => '<Separator>' },

   		{ path        => '/File/Quit',
		accelerator => '<control>Q',
     		callback    => sub { Gtk->exit( 0 ); } },

		{ path        => '/_Help',
 		type        => '<LastBranch>' },
	   		{ path        => '/_Help/About',
			callback    => sub { MenuAbout( $VERSION ); } }
	);




	## main window
	##############
	$widgets->{'wdwMain'} = new Gtk::Window( "toplevel" );
	$widgets->{'wdwMain'}->set_title( "File2DiVX3Pass ".$VERSION );
	$widgets->{'wdwMain'}->set_policy( $false, $true, $false );
	$widgets->{'wdwMain'}->set_position( "center" );
	$widgets->{'wdwMain'}->border_width( 5 );

	## maintop vbox
	###############
	$widgets->{'vbMainTop'} = new Gtk::VBox( $false, 2 );
	$widgets->{'wdwMain'}->add( $widgets->{'vbMainTop'} );

	## menu
	#######
	$widgets->{'mbarMenu'} = MakeMenu( $widgets, @menu_items );
	$widgets->{'vbMainTop'}->add( $widgets->{'mbarMenu'} );
	$widgets->{'vbMainTop'}->set_child_packing( $widgets->{'mbarMenu'}, $false, $true, 2, "start" );

	## frame
	########
	$widgets->{'frmMain'} = new Gtk::Frame();
	$widgets->{'vbMainTop'}->add( $widgets->{'frmMain'} );
	$widgets->{'vbMainTop'}->set_child_packing( $widgets->{'frmMain'}, $false, $true, 2, "start" );

	## main vbox
	############
	$widgets->{'vbMain'} = new Gtk::VBox( $false, 2 );
	$widgets->{'frmMain'}->add( $widgets->{'vbMain'} );


		## input file
		#############
		$widgets->{'hbInput'} = new Gtk::HBox( $false, 1 );
	$widgets->{'vbMain'}->add( $widgets->{'hbInput'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'hbInput'}, $false, $true, 2, "start" );
			$widgets->{'lblInput'} = new Gtk::Label( "Input file " );
			$widgets->{'entryInput'} = new Gtk::Entry();
			$widgets->{'btnInput'} = new Gtk::Button( "  Select file  " );
			$widgets->{'btnInput'}->border_width( 2 );
		$widgets->{'hbInput'}->add( $widgets->{'lblInput'} );
		$widgets->{'hbInput'}->set_child_packing( $widgets->{'lblInput'}, $false, $true, 5, "start" );
		$widgets->{'hbInput'}->add( $widgets->{'entryInput'} );
		$widgets->{'hbInput'}->set_child_packing( $widgets->{'entryInput'}, $false, $true, 5, "start" );
		$widgets->{'hbInput'}->add( $widgets->{'btnInput'} );
		$widgets->{'hbInput'}->set_child_packing( $widgets->{'btnInput'}, $false, $true, 5, "start" );

		## output file
		##############
		$widgets->{'hbOutput'} = new Gtk::HBox( $false, 2 );
	$widgets->{'vbMain'}->add( $widgets->{'hbOutput'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'hbOutput'}, $false, $true, 2, "start" );
			$widgets->{'lblOutput'} = new Gtk::Label( "Output file" );
			$widgets->{'entryOutput'} = new Gtk::Entry();
			$widgets->{'entryOutput'}->set_text( "out.divx.avi" );
		$widgets->{'hbOutput'}->add( $widgets->{'lblOutput'} );
		$widgets->{'hbOutput'}->set_child_packing( $widgets->{'lblOutput'}, $false, $true, 2, "start" );
		$widgets->{'hbOutput'}->add( $widgets->{'entryOutput'} );
		$widgets->{'hbOutput'}->set_child_packing( $widgets->{'entryOutput'}, $true, $true, 2, "start" );



		## separator
		############
		$widgets->{'sep1'} = new Gtk::HSeparator();
	$widgets->{'vbMain'}->add( $widgets->{'sep1'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'sep1'}, $false, $true, 2, "start" );



		## audio bitrate
		################
		$widgets->{'hbAudioBrate'} = new Gtk::HBox( $false, 1 );
	$widgets->{'vbMain'}->add( $widgets->{'hbAudioBrate'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'hbAudioBrate'}, $false, $true, 2, "start" );
			$widgets->{'lblAudioBrate'} = new Gtk::Label( "Audio MP3 bitrate" );
			$widgets->{'cmbAudioBrate'} = new Gtk::Combo();
			$widgets->{'cmbAudioBrate'}->set_popdown_strings( '32', '40', '48', '56', '64', '80', '96', '112', '128', '160', '192', '224', '256', '320' );
			$widgets->{'cmbAudioBrate'}->set_usize( 50, 0);
			$widgets->{'cmbAudioBrate'}->list->select_item( 8 );
		$widgets->{'hbAudioBrate'}->add( $widgets->{'lblAudioBrate'} );
		$widgets->{'hbAudioBrate'}->set_child_packing( $widgets->{'lblAudioBrate'}, $false, $true, 2, "start" );
		$widgets->{'hbAudioBrate'}->add( $widgets->{'cmbAudioBrate'} );
		$widgets->{'hbAudioBrate'}->set_child_packing( $widgets->{'cmbAudioBrate'}, $false, $true, 2, "start" );
			$widgets->{'lblAudioRate'} = new Gtk::Label( "Bitrate is" );
			$widgets->{'cmbAudioRate'} = new Gtk::Combo();
			$widgets->{'cmbAudioRate'}->set_popdown_strings( 'constant', 'average', 'variable' );
			$widgets->{'cmbAudioRate'}->set_usize( 100, 0);
			$widgets->{'cmbAudioRate'}->list->select_item( 1 );
		$widgets->{'hbAudioBrate'}->add( $widgets->{'cmbAudioRate'} );
		$widgets->{'hbAudioBrate'}->set_child_packing( $widgets->{'cmbAudioRate'}, $false, $true, 2, "end" );
		$widgets->{'hbAudioBrate'}->add( $widgets->{'lblAudioRate'} );
		$widgets->{'hbAudioBrate'}->set_child_packing( $widgets->{'lblAudioRate'}, $false, $true, 2, "end" );



		## separator
		############
		$widgets->{'sep2'} = new Gtk::HSeparator();
	$widgets->{'vbMain'}->add( $widgets->{'sep2'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'sep2'}, $false, $true, 2, "start" );



		## file length
		##############
		$widgets->{'hbLength'} = new Gtk::HBox( $false, 1 );
	$widgets->{'vbMain'}->add( $widgets->{'hbLength'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'hbLength'}, $false, $true, 2, "start" );
			$widgets->{'lblLength'} = new Gtk::Label( "File length" );
			$widgets->{'entryLength'} = new Gtk::Entry();
			$widgets->{'entryLength'}->set_usize( 55, 0 );
			$widgets->{'lblLength2'} = new Gtk::Label( "minutes" );
		$widgets->{'hbLength'}->add( $widgets->{'lblLength'} );
		$widgets->{'hbLength'}->set_child_packing( $widgets->{'lblLength'}, $false, $true, 2, "start" );
		$widgets->{'hbLength'}->add( $widgets->{'entryLength'} );
		$widgets->{'hbLength'}->set_child_packing( $widgets->{'entryLength'}, $false, $true, 2, "start" );
		$widgets->{'hbLength'}->add( $widgets->{'lblLength2'} );
		$widgets->{'hbLength'}->set_child_packing( $widgets->{'lblLength2'}, $false, $true, 2, "start" );

		## cd size
		##########
		$widgets->{'hbSize'} = new Gtk::HBox( $false, 1 );
	$widgets->{'vbMain'}->add( $widgets->{'hbSize'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'hbSize'}, $false, $true, 2, "start" );
			$widgets->{'lblSize'} = new Gtk::Label( "CD size    " );
			$widgets->{'entrySize'} = new Gtk::Entry();
			$widgets->{'entrySize'}->set_text( "700" );
			$widgets->{'entrySize'}->set_usize( 50, 0 );
			$widgets->{'lblSize2'} = new Gtk::Label( "Mb" );
		$widgets->{'hbSize'}->add( $widgets->{'lblSize'} );
		$widgets->{'hbSize'}->set_child_packing( $widgets->{'lblSize'}, $false, $true, 2, "start" );
		$widgets->{'hbSize'}->add( $widgets->{'entrySize'} );
		$widgets->{'hbSize'}->set_child_packing( $widgets->{'entrySize'}, $false, $true, 2, "start" );
		$widgets->{'hbSize'}->add( $widgets->{'lblSize2'} );
		$widgets->{'hbSize'}->set_child_packing( $widgets->{'lblSize2'}, $false, $true, 2, "start" );
			$widgets->{'chkbtnOutputFPS'} = new Gtk::CheckButton( "Output FPS" );
			$widgets->{'entryOutputFPS'} = new Gtk::Entry();
			$widgets->{'entryOutputFPS'}->set_text( "25" );
			$widgets->{'entryOutputFPS'}->set_usize( 55, 0 );
			$widgets->{'entryOutputFPS'}->set_sensitive( $false );
		$widgets->{'hbSize'}->add( $widgets->{'entryOutputFPS'} );
		$widgets->{'hbSize'}->set_child_packing( $widgets->{'entryOutputFPS'}, $false, $true, 2, "end" );
		$widgets->{'hbSize'}->add( $widgets->{'chkbtnOutputFPS'} );
		$widgets->{'hbSize'}->set_child_packing( $widgets->{'chkbtnOutputFPS'}, $false, $true, 2, "end" );

		## scaling
		##########
		$widgets->{'hbScale'} = new Gtk::HBox( $false, 1 );
	$widgets->{'vbMain'}->add( $widgets->{'hbScale'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'hbScale'}, $false, $true, 2, "start" );
			$widgets->{'lblScale'} = new Gtk::Label( "Scale to W x H" );
			$widgets->{'entryScaleWidth'} = new Gtk::Entry();
			$widgets->{'entryScaleWidth'}->set_text( "480" );
			$widgets->{'entryScaleWidth'}->set_usize( 40, 0 );
			$widgets->{'lblScalex'} = new Gtk::Label( "x" );
			$widgets->{'entryScaleHeight'} = new Gtk::Entry();
			$widgets->{'entryScaleHeight'}->set_text( "360" );
			$widgets->{'entryScaleHeight'}->set_usize( 40, 0 );
			$widgets->{'rbtnScale43'} = new Gtk::RadioButton( "4:3" );
			$widgets->{'rbtnScale169'} = new Gtk::RadioButton( "16:9", $widgets->{'rbtnScale43'} );
		$widgets->{'hbScale'}->add( $widgets->{'lblScale'} );
		$widgets->{'hbScale'}->set_child_packing( $widgets->{'lblScale'}, $false, $true, 2, "start" );
		$widgets->{'hbScale'}->add( $widgets->{'entryScaleWidth'} );
		$widgets->{'hbScale'}->set_child_packing( $widgets->{'entryScaleWidth'}, $false, $true, 2, "start" );
		$widgets->{'hbScale'}->add( $widgets->{'lblScalex'} );
		$widgets->{'hbScale'}->set_child_packing( $widgets->{'lblScalex'}, $false, $true, 2, "start" );
		$widgets->{'hbScale'}->add( $widgets->{'entryScaleHeight'} );
		$widgets->{'hbScale'}->set_child_packing( $widgets->{'entryScaleHeight'}, $false, $true, 2, "start" );
		$widgets->{'hbScale'}->add( $widgets->{'rbtnScale43'} );
		$widgets->{'hbScale'}->set_child_packing( $widgets->{'rbtnScale43'}, $false, $true, 2, "end" );
		$widgets->{'hbScale'}->add( $widgets->{'rbtnScale169'} );
		$widgets->{'hbScale'}->set_child_packing( $widgets->{'rbtnScale169'}, $false, $true, 2, "end" );

		## video rate + bpp
		###################
		$widgets->{'hbVideoBrate'} = new Gtk::HBox( $false, 1 );
	$widgets->{'vbMain'}->add( $widgets->{'hbVideoBrate'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'hbVideoBrate'}, $false, $true, 2, "start" );
			$widgets->{'lblVideoBrate'} = new Gtk::Label( "Video bitrate" );
			$widgets->{'entryVideoBrate'} = new Gtk::Entry();
			$widgets->{'entryVideoBrate'}->set_usize( 55, 0 );
		$widgets->{'hbVideoBrate'}->add( $widgets->{'lblVideoBrate'} );
		$widgets->{'hbVideoBrate'}->set_child_packing( $widgets->{'lblVideoBrate'}, $false, $true, 2, "start" );
		$widgets->{'hbVideoBrate'}->add( $widgets->{'entryVideoBrate'} );
		$widgets->{'hbVideoBrate'}->set_child_packing( $widgets->{'entryVideoBrate'}, $false, $true, 2, "start" );
			$widgets->{'lblVideoBPP'} = new Gtk::Label( "BPP" );
			$widgets->{'entryVideoBPP'} = new Gtk::Entry();
			$widgets->{'entryVideoBPP'}->set_usize( 55, 0 );
		$widgets->{'hbVideoBrate'}->add( $widgets->{'entryVideoBPP'} );
		$widgets->{'hbVideoBrate'}->set_child_packing( $widgets->{'entryVideoBPP'}, $false, $true, 2, "end" );
		$widgets->{'hbVideoBrate'}->add( $widgets->{'lblVideoBPP'} );
		$widgets->{'hbVideoBrate'}->set_child_packing( $widgets->{'lblVideoBPP'}, $false, $true, 2, "end" );


		## lib + pass
		#############
		$widgets->{'hbCodecPass'} = new Gtk::HBox( $false, 1 );
	$widgets->{'vbMain'}->add( $widgets->{'hbCodecPass'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'hbCodecPass'}, $false, $true, 2, "start" );
			$widgets->{'lblCodec'} = new Gtk::Label( "Video codec" );
			$widgets->{'cmbCodec'} = new Gtk::Combo();
			$widgets->{'cmbCodec'}->set_popdown_strings( 'divx4','lavc' );
			$widgets->{'cmbCodec'}->set_usize( 75, 0);
		$widgets->{'hbCodecPass'}->add( $widgets->{'lblCodec'} );
		$widgets->{'hbCodecPass'}->set_child_packing( $widgets->{'lblCodec'}, $false, $true, 2, "start" );
		$widgets->{'hbCodecPass'}->add( $widgets->{'cmbCodec'} );
		$widgets->{'hbCodecPass'}->set_child_packing( $widgets->{'cmbCodec'}, $false, $true, 2, "start" );
			$widgets->{'lblPass'} = new Gtk::Label( "Pass" );
			$widgets->{'cmbPass'} = new Gtk::Combo();
			$widgets->{'cmbPass'}->set_popdown_strings( '1-pass', '2-pass', '3-pass' );
			$widgets->{'cmbPass'}->set_usize( 75, 0);
			$widgets->{'cmbPass'}->list->select_item( 2 );
		$widgets->{'hbCodecPass'}->add( $widgets->{'cmbPass'} );
		$widgets->{'hbCodecPass'}->set_child_packing( $widgets->{'cmbPass'}, $false, $true, 2, "end" );
		$widgets->{'hbCodecPass'}->add( $widgets->{'lblPass'} );
		$widgets->{'hbCodecPass'}->set_child_packing( $widgets->{'lblPass'}, $false, $true, 2, "end" );



		## separator
		############
		$widgets->{'sep3'} = new Gtk::HSeparator();
	$widgets->{'vbMain'}->add( $widgets->{'sep3'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'sep3'}, $false, $true, 2, "start" );



		## start
		########
		$widgets->{'btnStart'} = new Gtk::Button( "start" );
	$widgets->{'vbMain'}->add( $widgets->{'btnStart'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'btnStart'}, $false, $true, 2, "start" );

		## stop
		#######
		$widgets->{'btnStop'} = new Gtk::Button( "stop" );
		$widgets->{'btnStop'}->set_sensitive( $false );
	$widgets->{'vbMain'}->add( $widgets->{'btnStop'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'btnStop'}, $false, $true, 2, "start" );


		## separator
		############
		$widgets->{'sep4'} = new Gtk::HSeparator();
	$widgets->{'vbMain'}->add( $widgets->{'sep4'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'sep4'}, $false, $true, 2, "start" );



		## actions label
		################
		$widgets->{'hbActions'} = new Gtk::HBox( $false, 1 );
	$widgets->{'vbMain'}->add( $widgets->{'hbActions'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'hbActions'}, $false, $false, 2, "start" );
			$widgets->{'lblActions'} = new Gtk::Label( "" );
			$widgets->{'lblActions'}->set_justify( "left" );
			$widgets->{'hbActions'}->add( $widgets->{'lblActions'} );
			$widgets->{'hbActions'}->set_child_packing( $widgets->{'lblActions'}, $false, $false, 2, "start" );

		## progress bar
		###############
		$widgets->{'pbarBar'} = new Gtk::ProgressBar;
	$widgets->{'vbMain'}->add( $widgets->{'pbarBar'} );
	$widgets->{'vbMain'}->set_child_packing( $widgets->{'pbarBar'}, $false, $true, 2, "start" );
		$widgets->{'pbarBar'}->set_orientation('left_to_right');
		$widgets->{'pbarBar'}->set_bar_style('continuous');
		$widgets->{'pbarBar'}->set_show_text(1);
		$widgets->{'pbarBar'}->set_activity_mode(0);
		$widgets->{'pbarBar'}->set_text_alignment(0.5, 0.5);
		$widgets->{'pbarBar'}->set_format_string('%P %%');
		$widgets->{'pbarBar'}->configure(0, 0, 100);





	## signals
	##########
	$widgets->{'wdwMain'}->signal_connect( "delete_event", \&wdwMainClose );
	$widgets->{'btnInput'}->signal_connect( "clicked", \&btnInputClicked, $widgets );
	$widgets->{'entrySize'}->signal_connect( "activate", \&entrySizeActivated, $widgets );
	$widgets->{'entryVideoBrate'}->signal_connect( "changed", \&entryVideoBrateChanged, $widgets );
	$widgets->{'cmbAudioBrate'}->entry->signal_connect( "changed", \&cmbAudioBrateEntryChanged, $widgets );
	$widgets->{'entryScaleWidth'}->signal_connect( "activate", \&entryScaleWidthActivated, $widgets );
	$widgets->{'entryScaleHeight'}->signal_connect( "activate", \&entryScaleHeightActivated, $widgets );
	$widgets->{'rbtnScale43'}->signal_connect( "toggled", \&rbtnScale43Toggled, $widgets );
	$widgets->{'btnStart'}->signal_connect( "clicked", \&btnStartClicked, $widgets );
	$widgets->{'btnStop'}->signal_connect( "clicked", \&btnStopClicked, $widgets );
	$widgets->{'chkbtnOutputFPS'}->signal_connect( "toggled", \&chkbtnOutputFPSToggled, $widgets );
	$widgets->{'entryOutputFPS'}->signal_connect( "activate", \&entryOutputFPSActivated, $widgets );

	bless ($widgets,$class);
	return $widgets;
}

sub MakeMenu
{
	my ($widgets,@menu_items) = @_;

	my $accel_group = new Gtk::AccelGroup();
	my $item_factory = new Gtk::ItemFactory( "Gtk::MenuBar", "<main>", $accel_group );
	$item_factory->create_items( @menu_items );
	$widgets->{'wdwMain'}->add_accel_group( $accel_group );
	return $item_factory->get_widget( "<main>" );
}

1;

